import { NumericF } from "@thi.ng/shader-ast";
/**
 * Sine oscillator (ported from thi.ng/dsp)
 *
 * @param phase - normalized phase
 * @param freq -
 * @param amp -
 * @param dc -
 */
export declare const sinOsc: (phase: NumericF, freq: NumericF, amp?: NumericF, dc?: NumericF) => import("@thi.ng/shader-ast").Term<"float">;
/**
 * Sawtooth oscillator (ported from thi.ng/dsp)
 *
 * @param phase - normalized phase
 * @param freq -
 * @param amp -
 * @param dc -
 */
export declare const sawOsc: (phase: NumericF, freq: NumericF, amp?: NumericF, dc?: NumericF) => import("@thi.ng/shader-ast").Term<"float">;
/**
 * Triangle oscillator (ported from thi.ng/dsp)
 *
 * @param phase - normalized phase
 * @param freq -
 * @param amp -
 * @param dc -
 */
export declare const triOsc: (phase: NumericF, freq: NumericF, amp?: NumericF, dc?: NumericF) => import("@thi.ng/shader-ast").Term<"float">;
/**
 * Rect oscillator w/ customizable duty cycle (default: 0.5) (ported from
 * thi.ng/dsp)
 *
 * @param phase - normalized phase
 * @param freq -
 * @param amp -
 * @param dc -
 * @param duty -
 */
export declare const rectOsc: (phase: NumericF, freq: NumericF, amp?: NumericF, dc?: NumericF, duty?: NumericF) => import("@thi.ng/shader-ast").Term<"float">;
//# sourceMappingURL=osc.d.ts.map